open Mapping
open Fof
open Term
open Print
open Arglean.Lean
open Arglean.Cop
open Arglean.Trace
open Matrix
open Utils

let nocontent_dcnf () =
  let defno = ref 0 in
  let def cl = incr defno; "def" ^ string_of_int !defno in
  def

let content_dcnf t =
  "'def(" ^ String.filter ((<>) '\'') (string_of_form t) ^ ")'"

let dcnf content =
  const_number % if content then content_dcnf else nocontent_dcnf ()


let shuffle_clause =
  List.map (fun lit -> Random.bits (), lit) %> List.sort compare %> List.map snd

let shuffle_matrix =
  List.map (fun cl -> Random.bits (), shuffle_clause cl) %> List.sort compare %> List.map snd

let prefix_hash m =
  if List.mem [(hash, [])] m then m
  else List.map (fun c -> if clause_positive c then hash_lit :: c else c) m

let mat_of_prematrix def =
  def_nnf !paths (if def then Some (dcnf !content) else None) %>
  (if def then identity else cnf) %>
  mat_of_cnf %>
  List.map rename_clause %>
  (*tap (pp_nl (pp_iter "\n" pp_print_clause) Format.std_formatter) %>*)
  prefix_hash %>
  (if !shuffle then shuffle_matrix else identity)

let mat_of_sform conj def =
  let unfold = unfold_neg %> unfold_impl %> unfold_equiv_lean def in
  mat_of_prematrix def %
  Prematrix.prematrix_of_sform unfold conj !ncpaths
