# collect solved files for a given prover
solved/%: out/%
	@mkdir -p "`dirname $@`"
	find $< -name "*.p" | \
	  xargs awk '((/Theorem/ || /Unsatisfiable/ || /Refutation found/) && !/Non-Theorem/){print FILENAME}' | uniq | \
	  xargs -L1 basename | sort > "$@"

tables/%:
	@mkdir -p "`dirname $@`"
	wc -l solved/$** | sed \$$d | \
	  awk '{print $$2 " " $$1}' | sed 's|.*solved/$*||' | sort -n > $@

discr/%: out/%
	@mkdir -p "`dirname $@`"
	sed -n 's|.*UCTDiscr: \(.*\)/\(.*\)|\1 \2|p' $</*.p | grep -v nan | \
          awk '{s1 += $$1; s2 += $$2; n++} END {print s1/n " " s2/n}'
