################################################################################
# Bushy / 10s / foreign provers
################################################################################

out/bushy/10s/e-2.0: $(BUSHY:bushy/%=\
out/bushy/10s/e-2.0/%)
out/bushy/10s/e-2.0/%: eprover-2.0 bushy/%
	@mkdir -p "`dirname $@`"
	-/usr/bin/time -o "$@.time" timeout 10 $^ \
	  --auto --tptp3-in --proof-object > $@


################################################################################
# Bushy / 10s / nonclausal
################################################################################

out/bushy/10s/nanocop-170603-nocut: $(BUSHY:bushy/%=\
out/bushy/10s/nanocop-170603-nocut/%)
out/bushy/10s/nanocop-170603-nocut/%: cop-170603/nanocop.native bushy/%
	@mkdir -p "`dirname $@`"
	-/usr/bin/time -o "$@.time" timeout 10 $^ \
	  -schedule 0 -nocut1 -nocut2 -nocut3 > "$@"

out/bushy/10s/nanocop-170603-nocut-noms: $(BUSHY:bushy/%=\
out/bushy/10s/nanocop-170603-nocut-noms/%)
out/bushy/10s/nanocop-170603-nocut-noms/%: cop-170603/nanocop.native bushy/%
	@mkdir -p "`dirname $@`"
	-/usr/bin/time -o "$@.time" timeout 10 $^ \
	  -schedule 0 -nocut1 -nocut2 -nocut3 -nominiscope > "$@"

out/bushy/10s/nanocop-170603-nocut-noms-noco: $(BUSHY:bushy/%=\
out/bushy/10s/nanocop-170603-nocut-noms-noco/%)
out/bushy/10s/nanocop-170603-nocut-noms-noco/%: cop-170603/nanocop.native bushy/%
	@mkdir -p "`dirname $@`"
	-/usr/bin/time -o "$@.time" timeout 10 $^ \
	  -schedule 0 -nocut1 -nocut2 -nocut3 -nominiscope -nocontent > "$@"

out/bushy/10s/nanocop-170603-nocut-noms-noco-noir: $(BUSHY:bushy/%=\
out/bushy/10s/nanocop-170603-nocut-noms-noco-noir/%)
out/bushy/10s/nanocop-170603-nocut-noms-noco-noir/%: cop-170603-ir/nanocop.native bushy/%
	@mkdir -p "`dirname $@`"
	-/usr/bin/time -o "$@.time" timeout 10 $^ \
	  -schedule 0 -nocut1 -nocut2 -nocut3 -nominiscope -nocontent -noimprovedreg > "$@"

out/bushy/10s/nanocop-170604-nocut-noms-noco-noir: $(BUSHY:bushy/%=\
out/bushy/10s/nanocop-170604-nocut-noms-noco-noir/%)
out/bushy/10s/nanocop-170604-nocut-noms-noco-noir/%: cop-170604/nanocop.native bushy/%
	@mkdir -p "`dirname $@`"
	-/usr/bin/time -o "$@.time" timeout 10 $^ \
	  -schedule 0 -nocut1 -nocut2 -nocut3 -nominiscope -nocontent -noimprovedreg > "$@"

out/bushy/10s/nanocop-170604-fv-nocut-noms-noco-noir-os: $(BUSHY:bushy/%=\
out/bushy/10s/nanocop-170604-fv-nocut-noms-noco-noir-os/%)
out/bushy/10s/nanocop-170604-fv-nocut-noms-noco-noir-os/%: cop-170604-fv/nanocop.native bushy/%
	@mkdir -p "`dirname $@`"
	-/usr/bin/time -o "$@.time" timeout 10 $^ \
	  -schedule 0 -nocut1 -nocut2 -nocut3 \
	  -nominiscope -nocontent -noimprovedreg -outersk > "$@"

out/bushy/10s/nanocop-170604-rl-nocut-noms-noco-noir-os: $(BUSHY:bushy/%=\
out/bushy/10s/nanocop-170604-rl-nocut-noms-noco-noir-os/%)
out/bushy/10s/nanocop-170604-rl-nocut-noms-noco-noir-os/%: cop-170604-rl/nanocop.native bushy/%
	@mkdir -p "`dirname $@`"
	-/usr/bin/time -o "$@.time" timeout 10 $^ \
	  -schedule 0 -nocut1 -nocut2 -nocut3 \
	  -nominiscope -nocontent -noimprovedreg -outersk > "$@"

out/bushy/10s/nanocop-170817-nocut-compat: $(BUSHY:bushy/%=\
out/bushy/10s/nanocop-170817-nocut-compat/%)
out/bushy/10s/nanocop-170817-nocut-compat/%: cop-170817/nanocop.native bushy/%
	@mkdir -p "`dirname $@`"
	-/usr/bin/time -o "$@.time" timeout 10 $^ \
	  -schedule 0 -nocut -compat > "$@"

out/bushy/10s/nanocop-170817-cut-compat: $(BUSHY:bushy/%=\
out/bushy/10s/nanocop-170817-cut-compat/%)
out/bushy/10s/nanocop-170817-cut-compat/%: cop-170817/nanocop.native bushy/%
	@mkdir -p "`dirname $@`"
	-/usr/bin/time -o "$@.time" timeout 10 $^ \
	  -schedule 0 -compat > "$@"

out/bushy/10s/plnanocop-170817-nocut-ecfix-infs: $(BUSHY:bushy/%=\
out/bushy/10s/plnanocop-170817-nocut-ecfix-infs/%)
out/bushy/10s/plnanocop-170817-nocut-ecfix-infs/%: cop-170817/prolog/nanocop.sh bushy/%
	@mkdir -p "`dirname $@`"
	-SET='[ecfix,infs]' /usr/bin/time -o "$@.time" timeout 10 $^ > "$@"

out/bushy/10s/plnanocop-170817-cut-ecfix-infs: $(BUSHY:bushy/%=\
out/bushy/10s/plnanocop-170817-cut-ecfix-infs/%)
out/bushy/10s/plnanocop-170817-cut-ecfix-infs/%: cop-170817/prolog/nanocop.sh bushy/%
	@mkdir -p "`dirname $@`"
	-SET='[cut,ecfix,infs]' /usr/bin/time -o "$@.time" timeout 10 $^ > "$@"

out/bushy/10s/plnanocop-170603-nocut-infs: $(BUSHY:bushy/%=\
out/bushy/10s/plnanocop-170603-nocut-infs/%)
out/bushy/10s/plnanocop-170603-nocut-infs/%: cop-170603/plnanocop/nanocop.sh bushy/%
	@mkdir -p "`dirname $@`"
	-SET='[infs]' /usr/bin/time -o "$@.time" timeout 10 $^ > "$@"

out/bushy/10s/nanocop-170829-cut: $(BUSHY:bushy/%=\
out/bushy/10s/nanocop-170829-cut/%)
out/bushy/10s/nanocop-170829-cut/%: cop-170829/nanocop.native bushy/%
	@mkdir -p "`dirname $@`"
	-/usr/bin/time -o "$@.time" timeout 10 $^ \
	  -schedule 0 > "$@"

out/bushy/10s/nanocop-170829-nocut: $(BUSHY:bushy/%=\
out/bushy/10s/nanocop-170829-nocut/%)
out/bushy/10s/nanocop-170829-nocut/%: cop-170829/nanocop.native bushy/%
	@mkdir -p "`dirname $@`"
	-/usr/bin/time -o "$@.time" timeout 10 $^ \
	  -schedule 0 -nocut > "$@"

out/bushy/10s/nanocop-170829-cut-middletest: $(BUSHY:bushy/%=\
out/bushy/10s/nanocop-170829-cut-middletest/%)
out/bushy/10s/nanocop-170829-cut-middletest/%: cop-170829/nanocop.native bushy/%
	@mkdir -p "`dirname $@`"
	-/usr/bin/time -o "$@.time" timeout 10 $^ \
	  -schedule 0 -middletest > "$@"

out/bushy/10s/nanocop-170904-cut-endtest: $(BUSHY:bushy/%=\
out/bushy/10s/nanocop-170904-cut-endtest/%)
out/bushy/10s/nanocop-170904-cut-endtest/%: cop-170904/nanocop.native bushy/%
	@mkdir -p "`dirname $@`"
	-/usr/bin/time -o "$@.time" timeout 10 $^ \
	  -schedule 0 -endtest > "$@"

out/bushy/10s/nanocop-170829-cut-nopaths: $(BUSHY:bushy/%=\
out/bushy/10s/nanocop-170829-cut-nopaths/%)
out/bushy/10s/nanocop-170829-cut-nopaths/%: cop-170829/nanocop.native bushy/%
	@mkdir -p "`dirname $@`"
	-/usr/bin/time -o "$@.time" timeout 10 $^ \
	  -schedule 0 -nopaths > "$@"

out/bushy/10s/nanocop-170829-nocut-nopaths: $(BUSHY:bushy/%=\
out/bushy/10s/nanocop-170829-nocut-nopaths/%)
out/bushy/10s/nanocop-170829-nocut-nopaths/%: cop-170829/nanocop.native bushy/%
	@mkdir -p "`dirname $@`"
	-/usr/bin/time -o "$@.time" timeout 10 $^ \
	  -schedule 0 -nocut -nopaths > "$@"

out/bushy/10s/nanocop-170829-nocut-middletest: $(BUSHY:bushy/%=\
out/bushy/10s/nanocop-170829-nocut-middletest/%)
out/bushy/10s/nanocop-170829-nocut-middletest/%: cop-170829/nanocop.native bushy/%
	@mkdir -p "`dirname $@`"
	-/usr/bin/time -o "$@.time" timeout 10 $^ \
	  -schedule 0 -nocut -middletest > "$@"



################################################################################
# Bushy / 10s / defcnf
################################################################################

out/bushy/10s/defcnf/plleancop-170608-nocut-conj: $(BUSHY:bushy/%=\
out/bushy/10s/defcnf/plleancop-170608-nocut-conj/%)
out/bushy/10s/defcnf/plleancop-170608-nocut-conj/%: cop-170608/prolog/leancop.sh bushy/%
	@mkdir -p "`dirname $@`"
	-SET='[def,conj]' /usr/bin/time -o "$@.time" timeout 10 $^ > "$@"

out/bushy/10s/defcnf/plleancop-170622-cut-conj-infs: $(BUSHY:bushy/%=\
out/bushy/10s/defcnf/plleancop-170622-cut-conj-infs/%)
out/bushy/10s/defcnf/plleancop-170622-cut-conj-infs/%: cop-170622/prolog/leancop.sh bushy/%
	@mkdir -p "`dirname $@`"
	-SET='[def,cut,conj,infs]' /usr/bin/time -o "$@.time" timeout 10 $^ > "$@"

out/bushy/10s/defcnf/lazycop-170901-nocut: $(BUSHY:bushy/%=\
out/bushy/10s/defcnf/lazycop-170901-nocut/%)
out/bushy/10s/defcnf/lazycop-170901-nocut/%: cop-170901/lazycop.native bushy/%
	@mkdir -p "`dirname $@`"
	-/usr/bin/time -o "$@.time" timeout 10 $^ \
	  -schedule 0 -nocut > "$@"

out/bushy/10s/defcnf/lazycop-170901-nocut-nopaths: $(BUSHY:bushy/%=\
out/bushy/10s/defcnf/lazycop-170901-nocut-nopaths/%)
out/bushy/10s/defcnf/lazycop-170901-nocut-nopaths/%: cop-170901/lazycop.native bushy/%
	@mkdir -p "`dirname $@`"
	-/usr/bin/time -o "$@.time" timeout 10 $^ \
	  -schedule 0 -nocut -nopaths > "$@"

out/bushy/10s/defcnf/lazycop-170901-cut-nopaths: $(BUSHY:bushy/%=\
out/bushy/10s/defcnf/lazycop-170901-cut-nopaths/%)
out/bushy/10s/defcnf/lazycop-170901-cut-nopaths/%: cop-170901/lazycop.native bushy/%
	@mkdir -p "`dirname $@`"
	-/usr/bin/time -o "$@.time" timeout 10 $^ \
	  -schedule 0 -nopaths > "$@"

out/bushy/10s/defcnf/lazycop-170901-cut-nopaths-ncpaths: $(BUSHY:bushy/%=\
out/bushy/10s/defcnf/lazycop-170901-cut-nopaths-ncpaths/%)
out/bushy/10s/defcnf/lazycop-170901-cut-nopaths-ncpaths/%: cop-170901/lazycop.native bushy/%
	@mkdir -p "`dirname $@`"
	-/usr/bin/time -o "$@.time" timeout 10 $^ \
	  -schedule 0 -nopaths -ncpaths > "$@"

out/bushy/10s/defcnf/lazycop-170817-cut-conj-compat: $(BUSHY:bushy/%=\
out/bushy/10s/defcnf/lazycop-170817-cut-conj-compat/%)
out/bushy/10s/defcnf/lazycop-170817-cut-conj-compat/%: cop-170817/lazycop.native bushy/%
	@mkdir -p "`dirname $@`"
	-/usr/bin/time -o "$@.time" timeout 10 $^ \
	  -schedule 0 \
	  -outersk -noimprovedlem -nominiscope -nocontent > "$@"

out/bushy/10s/defcnf/lazycop-170605-nocut: $(BUSHY:bushy/%=\
out/bushy/10s/defcnf/lazycop-170605-nocut/%)
out/bushy/10s/defcnf/lazycop-170605-nocut/%: cop-170605/lazycop.native bushy/%
	@mkdir -p "`dirname $@`"
	-/usr/bin/time -o "$@.time" timeout 10 $^ \
	  -schedule 0 -nocut1 -nocut2 -nocut3 > "$@"

out/bushy/10s/defcnf/lazycop-170605-nocut-nopaths: $(BUSHY:bushy/%=\
out/bushy/10s/defcnf/lazycop-170605-nocut-nopaths/%)
out/bushy/10s/defcnf/lazycop-170605-nocut-nopaths/%: cop-170605/lazycop.native bushy/%
	@mkdir -p "`dirname $@`"
	-/usr/bin/time -o "$@.time" timeout 10 $^ \
	  -schedule 0 -nocut1 -nocut2 -nocut3 -nopaths > "$@"

out/bushy/10s/defcnf/lazycop-170605-nopaths: $(BUSHY:bushy/%=\
out/bushy/10s/defcnf/lazycop-170605-nopaths/%)
out/bushy/10s/defcnf/lazycop-170605-nopaths/%: cop-170605/lazycop.native bushy/%
	@mkdir -p "`dirname $@`"
	-/usr/bin/time -o "$@.time" timeout 10 $^ \
	  -schedule 0 -nopaths > "$@"

out/bushy/10s/defcnf/lazycop-170209-cut: $(BUSHY:bushy/%=\
out/bushy/10s/defcnf/lazycop-170209-cut/%)
out/bushy/10s/defcnf/lazycop-170209-cut/%: cop-170209/lazycop.native bushy/%
	@mkdir -p "`dirname $@`"
	-/usr/bin/time -o "$@.time" timeout 10 $^ \
	  -schedule 0 > "$@"

out/bushy/10s/defcnf/lazycop-170209-nocut: $(BUSHY:bushy/%=\
out/bushy/10s/defcnf/lazycop-170209-nocut/%)
out/bushy/10s/defcnf/lazycop-170209-nocut/%: cop-170209/lazycop.native bushy/%
	@mkdir -p "`dirname $@`"
	-/usr/bin/time -o "$@.time" timeout 10 $^ \
	  -schedule 0 -nocut1 -nocut2 -nocut3 > "$@"


MONTEPARAMS = -exppol cutlit -simdepth 50 -naivereward 1 -mlreward 0

out/bushy/10s/defcnf/montecop-170209: $(BUSHY:bushy/%=\
out/bushy/10s/defcnf/montecop-170209/%)
out/bushy/10s/defcnf/montecop-170209/%: cop-170209/montecop.native bushy/%
	@mkdir -p "`dirname $@`"
	-/usr/bin/time -o "$@.time" timeout 10 $^ \
	  $(MONTEPARAMS) > "$@"

out/bushy/10s/defcnf/montecop-170209-nocut: $(BUSHY:bushy/%=\
out/bushy/10s/defcnf/montecop-170209-nocut/%)
out/bushy/10s/defcnf/montecop-170209-nocut/%: cop-170209/montecop.native bushy/%
	@mkdir -p "`dirname $@`"
	-/usr/bin/time -o "$@.time" timeout 10 $^ \
	  $(MONTEPARAMS) -exppol fst > "$@"

out/bushy/10s/defcnf/montecop-170209-cutcla: $(BUSHY:bushy/%=\
out/bushy/10s/defcnf/montecop-170209-cutcla/%)
out/bushy/10s/defcnf/montecop-170209-cutcla/%: cop-170209/montecop.native bushy/%
	@mkdir -p "`dirname $@`"
	-/usr/bin/time -o "$@.time" timeout 10 $^ \
	  $(MONTEPARAMS) -exppol cutcla > "$@"

out/bushy/10s/defcnf/montecop-170209-constprob: $(BUSHY:bushy/%=\
out/bushy/10s/defcnf/montecop-170209-constprob/%)
out/bushy/10s/defcnf/montecop-170209-constprob/%: cop-170209/montecop.native bushy/%
	@mkdir -p "`dirname $@`"
	-/usr/bin/time -o "$@.time" timeout 10 $^ \
	  $(MONTEPARAMS) -constprob 1 -invprob 0 > "$@"

out/bushy/10s/defcnf/montecop-170209-bayesprob: $(BUSHY:bushy/%=\
out/bushy/10s/defcnf/montecop-170209-bayesprob/%)
out/bushy/10s/defcnf/montecop-170209-bayesprob/%: cop-170209/montecop.native bushy/%
	@mkdir -p "`dirname $@`"
	-/usr/bin/time -o "$@.time" timeout 10 $^ \
	  $(MONTEPARAMS) -bayesprob 1 -invprob 0 \
	  -cdata out/bushy/60s/defcnf/lazycop-170209-md10.cdata > "$@"

out/bushy/10s/defcnf/montecop-170209-randrew: $(BUSHY:bushy/%=\
out/bushy/10s/defcnf/montecop-170209-randrew/%)
out/bushy/10s/defcnf/montecop-170209-randrew/%: cop-170209/montecop.native bushy/%
	@mkdir -p "`dirname $@`"
	-/usr/bin/time -o "$@.time" timeout 10 $^ \
	  $(MONTEPARAMS) -randreward 1 -naivereward 0 > "$@"

out/bushy/10s/defcnf/montecop-170209-sizerew: $(BUSHY:bushy/%=\
out/bushy/10s/defcnf/montecop-170209-sizerew/%)
out/bushy/10s/defcnf/montecop-170209-sizerew/%: cop-170209/montecop.native bushy/%
	@mkdir -p "`dirname $@`"
	-/usr/bin/time -o "$@.time" timeout 10 $^ \
	  $(MONTEPARAMS) -sizereward 1 -naivereward 0 > "$@"

out/bushy/10s/defcnf/montecop-170209-mlrew: $(BUSHY:bushy/%=\
out/bushy/10s/defcnf/montecop-170209-mlrew/%)
out/bushy/10s/defcnf/montecop-170209-mlrew/%: cop-170209/montecop.native bushy/%
	@mkdir -p "`dirname $@`"
	-/usr/bin/time -o "$@.time" timeout 10 $^ \
	  $(MONTEPARAMS) -mlreward 1 -naivereward 0 \
	  -ldata out/bushy/60s/defcnf/lazycop-170209-md10.ldata > "$@"

out/bushy/10s/defcnf/montecop-170209-all: \
  out/bushy/10s/defcnf/lazycop-170209-cut \
  out/bushy/10s/defcnf/lazycop-170209-nocut \
  out/bushy/10s/defcnf/montecop-170209 \
  out/bushy/10s/defcnf/montecop-170209-nocut \
  out/bushy/10s/defcnf/montecop-170209-cutcla \
  out/bushy/10s/defcnf/montecop-170209-constprob \
  out/bushy/10s/defcnf/montecop-170209-bayesprob \
  out/bushy/10s/defcnf/montecop-170209-randrew \
  out/bushy/10s/defcnf/montecop-170209-sizerew \
  out/bushy/10s/defcnf/montecop-170209-mlrew


define bushy-10s-defcnf-montecop-170209-simdepth
out/bushy/10s/defcnf/montecop-170209-simdepth$(SIMDEPTH): $$(BUSHY:bushy/%=\
out/bushy/10s/defcnf/montecop-170209-simdepth$(SIMDEPTH)/%)
out/bushy/10s/defcnf/montecop-170209-simdepth$(SIMDEPTH)/%: cop-170209/montecop.native bushy/%
	@mkdir -p "`dirname $$@`"
	-/usr/bin/time -o "$$@.time" timeout 10 $$^ \
	  $$(MONTEPARAMS) -simdepth $(SIMDEPTH) > "$$@"
endef

SIMDEPTHS=$(shell seq 0 128)
#$(foreach SIMDEPTH,$(SIMDEPTHS),$(eval $(bushy-10s-defcnf-montecop-170209-simdepth)))
out/bushy/10s/defcnf/montecop-170209-simdepths: $(SIMDEPTHS:%=\
out/bushy/10s/defcnf/montecop-170209-simdepth%)


define bushy-10s-defcnf-montecop-170209-maxiters
out/bushy/10s/defcnf/montecop-170209-maxiters$(MAXITERS): $$(BUSHY:bushy/%=\
out/bushy/10s/defcnf/montecop-170209-maxiters$(MAXITERS)/%)
out/bushy/10s/defcnf/montecop-170209-maxiters$(MAXITERS)/%: cop-170209/montecop.native bushy/%
	@mkdir -p "`dirname $$@`"
	-/usr/bin/time -o "$$@.time" timeout 10 $$^ \
	  $$(MONTEPARAMS) -maxiters $(MAXITERS) > "$$@"
endef

MAXITERSS=$(shell seq 0 128)
#$(foreach MAXITERS,$(MAXITERSS),$(eval $(bushy-10s-defcnf-montecop-170209-maxiters)))
out/bushy/10s/defcnf/montecop-170209-maxiterss: $(MAXITERSS:%=\
out/bushy/10s/defcnf/montecop-170209-maxiters%)


define bushy-10s-defcnf-montecop-170209-exploration
out/bushy/10s/defcnf/montecop-170209-exploration$(EXPLORATION): $$(BUSHY:bushy/%=\
out/bushy/10s/defcnf/montecop-170209-exploration$(EXPLORATION)/%)
out/bushy/10s/defcnf/montecop-170209-exploration$(EXPLORATION)/%: cop-170209/montecop.native bushy/%
	@mkdir -p "`dirname $$@`"
	-/usr/bin/time -o "$$@.time" timeout 10 $$^ \
	  $$(MONTEPARAMS) -exploration $(EXPLORATION) > "$$@"
endef

EXPLORATIONS=$(shell LC_NUMERIC=C seq 0 0.1 5)
#$(foreach EXPLORATION,$(EXPLORATIONS),$(eval $(bushy-10s-defcnf-montecop-170209-exploration)))
out/bushy/10s/defcnf/montecop-170209-explorations: $(EXPLORATIONS:%=\
out/bushy/10s/defcnf/montecop-170209-exploration%)


define bushy-10s-defcnf-montecop-170209-mlrew-exploration
out/bushy/10s/defcnf/montecop-170209-mlrew-exploration$(EXPLORATION): $$(BUSHY:bushy/%=\
out/bushy/10s/defcnf/montecop-170209-mlrew-exploration$(EXPLORATION)/%)
out/bushy/10s/defcnf/montecop-170209-mlrew-exploration$(EXPLORATION)/%: cop-170209/montecop.native bushy/%
	@mkdir -p "`dirname $$@`"
	-/usr/bin/time -o "$$@.time" timeout 10 $$^ \
	  $$(MONTEPARAMS) -mlreward 1 -naivereward 0 -exploration $(EXPLORATION) \
	  -ldata out/bushy/60s/defcnf/lazycop-170209-md10.ldata > "$$@"
endef

#$(foreach EXPLORATION,$(EXPLORATIONS),$(eval $(bushy-10s-defcnf-montecop-170209-mlrew-exploration)))
out/bushy/10s/defcnf/montecop-170209-mlrew-explorations: $(EXPLORATIONS:%=\
out/bushy/10s/defcnf/montecop-170209-mlrew-exploration%)




################################################################################
# Bushy / 10s / nodefcnf
################################################################################

out/bushy/10s/nodefcnf/plleancop-170622-nocut-conj-nopaths-infs: $(BUSHY:bushy/%=\
out/bushy/10s/nodefcnf/plleancop-170622-nocut-conj-nopaths-infs/%)
out/bushy/10s/nodefcnf/plleancop-170622-nocut-conj-nopaths-infs/%: cop-170622/prolog/leancop.sh bushy/%
	@mkdir -p "`dirname $@`"
	-SET='[nodef,conj,nopaths,infs]' /usr/bin/time -o "$@.time" timeout 10 $^ > "$@"

out/bushy/10s/nodefcnf/plleancop-170622-nocut-conj-infs: $(BUSHY:bushy/%=\
out/bushy/10s/nodefcnf/plleancop-170622-nocut-conj-infs/%)
out/bushy/10s/nodefcnf/plleancop-170622-nocut-conj-infs/%: cop-170622/prolog/leancop.sh bushy/%
	@mkdir -p "`dirname $@`"
	-SET='[nodef,conj,infs]' /usr/bin/time -o "$@.time" timeout 10 $^ > "$@"

out/bushy/10s/nodefcnf/plleancop-170622-nocut-noconj-infs: $(BUSHY:bushy/%=\
out/bushy/10s/nodefcnf/plleancop-170622-nocut-noconj-infs/%)
out/bushy/10s/nodefcnf/plleancop-170622-nocut-noconj-infs/%: cop-170622/prolog/leancop.sh bushy/%
	@mkdir -p "`dirname $@`"
	-SET='[nodef,infs]' /usr/bin/time -o "$@.time" timeout 10 $^ > "$@"

out/bushy/10s/nodefcnf/plleancop-170622-cut-conj-infs: $(BUSHY:bushy/%=\
out/bushy/10s/nodefcnf/plleancop-170622-cut-conj-infs/%)
out/bushy/10s/nodefcnf/plleancop-170622-cut-conj-infs/%: cop-170622/prolog/leancop.sh bushy/%
	@mkdir -p "`dirname $@`"
	-SET='[nodef,cut,conj,infs]' /usr/bin/time -o "$@.time" timeout 10 $^ > "$@"

out/bushy/10s/nodefcnf/lazycop-170814-nocut-conj-nopaths-compat: $(BUSHY:bushy/%=\
out/bushy/10s/nodefcnf/lazycop-170814-nocut-conj-nopaths-compat/%)
out/bushy/10s/nodefcnf/lazycop-170814-nocut-conj-nopaths-compat/%: cop-170814/lazycop.native bushy/%
	@mkdir -p "`dirname $@`"
	-/usr/bin/time -o "$@.time" timeout 10 $^ -nodefcnf \
	  -schedule 0 -nocut -nopaths \
	  -outersk -noimprovedlem -nominiscope -nocontent > "$@"

out/bushy/10s/nodefcnf/lazycop-170814-nocut-conj-compat: $(BUSHY:bushy/%=\
out/bushy/10s/nodefcnf/lazycop-170814-nocut-conj-compat/%)
out/bushy/10s/nodefcnf/lazycop-170814-nocut-conj-compat/%: cop-170814/lazycop.native bushy/%
	@mkdir -p "`dirname $@`"
	-/usr/bin/time -o "$@.time" timeout 10 $^ -nodefcnf \
	  -schedule 0 -nocut \
	  -outersk -noimprovedlem -nominiscope -nocontent > "$@"

out/bushy/10s/nodefcnf/lazycop-170816-nocut-conj-compat: $(BUSHY:bushy/%=\
out/bushy/10s/nodefcnf/lazycop-170816-nocut-conj-compat/%)
out/bushy/10s/nodefcnf/lazycop-170816-nocut-conj-compat/%: cop-170816/lazycop.native bushy/%
	@mkdir -p "`dirname $@`"
	-/usr/bin/time -o "$@.time" timeout 10 $^ -nodefcnf \
	  -schedule 0 -nocut \
	  -outersk -noimprovedlem -nominiscope -nocontent > "$@"

out/bushy/10s/nodefcnf/lazycop-170816-nocut-noconj-compat: $(BUSHY:bushy/%=\
out/bushy/10s/nodefcnf/lazycop-170816-nocut-noconj-compat/%)
out/bushy/10s/nodefcnf/lazycop-170816-nocut-noconj-compat/%: cop-170816/lazycop.native bushy/%
	@mkdir -p "`dirname $@`"
	-/usr/bin/time -o "$@.time" timeout 10 $^ -nodefcnf \
	  -schedule 0 -nocut -noconj \
	  -outersk -noimprovedlem -nominiscope -nocontent > "$@"

out/bushy/10s/nodefcnf/lazycop-170816-cut-conj-compat: $(BUSHY:bushy/%=\
out/bushy/10s/nodefcnf/lazycop-170816-cut-conj-compat/%)
out/bushy/10s/nodefcnf/lazycop-170816-cut-conj-compat/%: cop-170816/lazycop.native bushy/%
	@mkdir -p "`dirname $@`"
	-/usr/bin/time -o "$@.time" timeout 10 $^ -nodefcnf \
	  -schedule 0 \
	  -outersk -noimprovedlem -nominiscope -nocontent > "$@"

out/bushy/10s/nodefcnf/lazycop-170817-cut-conj-compat: $(BUSHY:bushy/%=\
out/bushy/10s/nodefcnf/lazycop-170817-cut-conj-compat/%)
out/bushy/10s/nodefcnf/lazycop-170817-cut-conj-compat/%: cop-170817/lazycop.native bushy/%
	@mkdir -p "`dirname $@`"
	-/usr/bin/time -o "$@.time" timeout 10 $^ -nodefcnf \
	  -schedule 0 \
	  -outersk -noimprovedlem -nominiscope -nocontent > "$@"

out/bushy/10s/nodefcnf/lazycop-170624-nocut-conj-nopaths-compat: $(BUSHY:bushy/%=\
out/bushy/10s/nodefcnf/lazycop-170624-nocut-conj-nopaths-compat/%)
out/bushy/10s/nodefcnf/lazycop-170624-nocut-conj-nopaths-compat/%: cop-170624/lazycop.native bushy/%
	@mkdir -p "`dirname $@`"
	-/usr/bin/time -o "$@.time" timeout 10 $^ -nodefcnf \
	  -schedule 0 -nocut -nopaths \
	  -outersk -noimprovedlem -nominiscope -nocontent > "$@"

out/bushy/10s/nodefcnf/lazycop-170622-nocut-conj-nopaths-compat: $(BUSHY:bushy/%=\
out/bushy/10s/nodefcnf/lazycop-170622-nocut-conj-nopaths-compat/%)
out/bushy/10s/nodefcnf/lazycop-170622-nocut-conj-nopaths-compat/%: cop-170622/lazycop.native bushy/%
	@mkdir -p "`dirname $@`"
	-/usr/bin/time -o "$@.time" timeout 10 $^ -nodefcnf \
	  -schedule 0 -nocut -nopaths \
	  -outersk -noimprovedlem -nominiscope -nocontent > "$@"


out/bushy/10s/nodefcnf/lazycop-170422-cut: $(BUSHY:bushy/%=\
out/bushy/10s/nodefcnf/lazycop-170422-cut/%)
out/bushy/10s/nodefcnf/lazycop-170422-cut/%: cop-170422/conticop.native bushy/%
	@mkdir -p "`dirname $@`"
	-/usr/bin/time -o "$@.time" timeout 10 $^ -nodefcnf \
	  -schedule 0 > "$@"

out/bushy/10s/nodefcnf/conticop-170422-cut: $(BUSHY:bushy/%=\
out/bushy/10s/nodefcnf/conticop-170422-cut/%)
out/bushy/10s/nodefcnf/conticop-170422-cut/%: cop-170422/conticop.native bushy/%
	@mkdir -p "`dirname $@`"
	-/usr/bin/time -o "$@.time" timeout 10 $^ -nodefcnf \
	  -schedule 0 > "$@"

out/bushy/10s/nodefcnf/stackcop-170422-cut: $(BUSHY:bushy/%=\
out/bushy/10s/nodefcnf/stackcop-170422-cut/%)
out/bushy/10s/nodefcnf/stackcop-170422-cut/%: cop-170422/stackcop.native bushy/%
	@mkdir -p "`dirname $@`"
	-/usr/bin/time -o "$@.time" timeout 10 $^ -nodefcnf \
	  -schedule 0 > "$@"

out/bushy/10s/lazycop-170209-cut: $(BUSHY:bushy/%=\
out/bushy/10s/lazycop-170209-cut/%)
out/bushy/10s/lazycop-170209-cut/%: cop-170209/lazycop.native bushy/%
	@mkdir -p "`dirname $@`"
	-/usr/bin/time -o "$@.time" timeout 10 $^ -nodefcnf \
	  -schedule 0 > "$@"

out/bushy/10s/lazycop-170209-nocut: $(BUSHY:bushy/%=\
out/bushy/10s/lazycop-170209-nocut/%)
out/bushy/10s/lazycop-170209-nocut/%: cop-170209/lazycop.native bushy/%
	@mkdir -p "`dirname $@`"
	-/usr/bin/time -o "$@.time" timeout 10 $^ -nodefcnf \
	  -schedule 0 -nocut1 -nocut2 -nocut3 > "$@"


MONTEPARAMS = -exppol cutlit -simdepth 50 -naivereward 1 -mlreward 0

out/bushy/10s/montecop-170209-nocut: $(BUSHY:bushy/%=\
out/bushy/10s/montecop-170209-nocut/%)
out/bushy/10s/montecop-170209-nocut/%: cop-170209/montecop.native bushy/%
	@mkdir -p "`dirname $@`"
	-/usr/bin/time -o "$@.time" timeout 10 $^ -nodefcnf \
	  $(MONTEPARAMS) -exppol fst > "$@"

out/bushy/10s/montecop-170209-cutcla: $(BUSHY:bushy/%=\
out/bushy/10s/montecop-170209-cutcla/%)
out/bushy/10s/montecop-170209-cutcla/%: cop-170209/montecop.native bushy/%
	@mkdir -p "`dirname $@`"
	-/usr/bin/time -o "$@.time" timeout 10 $^ -nodefcnf \
	  $(MONTEPARAMS) -exppol cutcla > "$@"

out/bushy/10s/montecop-170209-constprob: $(BUSHY:bushy/%=\
out/bushy/10s/montecop-170209-constprob/%)
out/bushy/10s/montecop-170209-constprob/%: cop-170209/montecop.native bushy/%
	@mkdir -p "`dirname $@`"
	-/usr/bin/time -o "$@.time" timeout 10 $^ -nodefcnf \
	  $(MONTEPARAMS) -constprob 1 -invprob 0 > "$@"

out/bushy/10s/montecop-170209-bayesprob: $(BUSHY:bushy/%=\
out/bushy/10s/montecop-170209-bayesprob/%)
out/bushy/10s/montecop-170209-bayesprob/%: cop-170209/montecop.native bushy/%
	@mkdir -p "`dirname $@`"
	-/usr/bin/time -o "$@.time" timeout 10 $^ -nodefcnf \
	  $(MONTEPARAMS) -bayesprob 1 -invprob 0 \
	  -cdata out/bushy/60s/lazycop-170207-ndc-md10.cdata > "$@"

out/bushy/10s/montecop-170209-randrew: $(BUSHY:bushy/%=\
out/bushy/10s/montecop-170209-randrew/%)
out/bushy/10s/montecop-170209-randrew/%: cop-170209/montecop.native bushy/%
	@mkdir -p "`dirname $@`"
	-/usr/bin/time -o "$@.time" timeout 10 $^ -nodefcnf \
	  $(MONTEPARAMS) -randreward 1 -naivereward 0 > "$@"

out/bushy/10s/montecop-170209-sizerew: $(BUSHY:bushy/%=\
out/bushy/10s/montecop-170209-sizerew/%)
out/bushy/10s/montecop-170209-sizerew/%: cop-170209/montecop.native bushy/%
	@mkdir -p "`dirname $@`"
	-/usr/bin/time -o "$@.time" timeout 10 $^ -nodefcnf \
	  $(MONTEPARAMS) -sizereward 1 -naivereward 0 > "$@"

out/bushy/10s/montecop-170209-mlrew: $(BUSHY:bushy/%=\
out/bushy/10s/montecop-170209-mlrew/%)
out/bushy/10s/montecop-170209-mlrew/%: cop-170209/montecop.native bushy/%
	@mkdir -p "`dirname $@`"
	-/usr/bin/time -o "$@.time" timeout 10 $^ -nodefcnf \
	  $(MONTEPARAMS) -mlreward 1 -naivereward 0 \
	  -ldata out/bushy/60s/lazycop-170207-ndc-md10.ldata > "$@"

define montecop-170209-simdepth
out/bushy/10s/montecop-170209-simdepth$(SIMDEPTH): $$(BUSHY:bushy/%=\
out/bushy/10s/montecop-170209-simdepth$(SIMDEPTH)/%)
out/bushy/10s/montecop-170209-simdepth$(SIMDEPTH)/%: cop-170209/montecop.native bushy/%
	@mkdir -p "`dirname $$@`"
	-/usr/bin/time -o "$$@.time" timeout 10 $$^ -nodefcnf \
	  $$(MONTEPARAMS) -simdepth $(SIMDEPTH) > "$$@"
endef

SIMDEPTHS=$(shell seq 0 64)
#$(foreach SIMDEPTH,$(SIMDEPTHS),$(eval $(montecop-170209-simdepth)))
out/bushy/10s/montecop-170209-simdepths: $(SIMDEPTHS:%=out/bushy/10s/montecop-170209-simdepth%)

define montecop-170209-maxiters
out/bushy/10s/montecop-170209-maxiters$(MAXITERS): $$(BUSHY:bushy/%=\
out/bushy/10s/montecop-170209-maxiters$(MAXITERS)/%)
out/bushy/10s/montecop-170209-maxiters$(MAXITERS)/%: cop-170209/montecop.native bushy/%
	@mkdir -p "`dirname $$@`"
	-/usr/bin/time -o "$$@.time" timeout 10 $$^ -nodefcnf \
	  $$(MONTEPARAMS) -maxiters $(MAXITERS) > "$$@"
endef

MAXITERSS=$(shell seq 0 128)
#$(foreach MAXITERS,$(MAXITERSS),$(eval $(montecop-170209-maxiters)))
out/bushy/10s/montecop-170209-maxiterss: $(MAXITERSS:%=out/bushy/10s/montecop-170209-maxiters%)

define montecop-170209-exploration
out/bushy/10s/montecop-170209-exploration$(EXPLORATION): $$(BUSHY:bushy/%=\
out/bushy/10s/montecop-170209-exploration$(EXPLORATION)/%)
out/bushy/10s/montecop-170209-exploration$(EXPLORATION)/%: cop-170209/montecop.native bushy/%
	@mkdir -p "`dirname $$@`"
	-/usr/bin/time -o "$$@.time" timeout 10 $$^ -nodefcnf \
	  $$(MONTEPARAMS) -exploration $(EXPLORATION) > "$$@"
endef

EXPLORATIONS=$(shell LC_NUMERIC=C seq 0 0.1 2)
#$(foreach EXPLORATION,$(EXPLORATIONS),$(eval $(montecop-170209-exploration)))
out/bushy/10s/montecop-170209-explorations: $(EXPLORATIONS:%=out/bushy/10s/montecop-170209-exploration%)


data/montecop-170209-%:
	@mkdir -p "`dirname $@`"
	wc -l solved/bushy/10s/* | sed -n 's/\s*\([0-9]*\)\s.*$*\(.*\)/\2 \1/p' | sort -n > $@

# monteCoP:
# - attenuation of previously used cps?
