open Cnf;;

let rec vs acc = function
  | A (_, l) -> List.fold_left vs acc l
  | V n -> Im.add n (1 + try Im.find n acc with Not_found -> 0) acc;;
let vs t = vs Im.empty t;;

let rec weight acc = function
  | V _ -> acc + 1024
  | A (f, []) -> acc + 1025 + f mod 1024
  | A (f, l) -> List.fold_left weight (acc + f mod 1024) l;;
let weight t = weight 0 t;;

let rec kbo1 f v = function
  V v' -> v = v'
| A (f', [s]) -> f = f' && kbo1 f v s
| _ -> false;;

let rec kbo s t =
  let vss = vs s and vst = vs t in
  (try Im.fold (fun v no ok -> ok && no < Im.find v vst) vss true with Not_found -> false) &&
  let ws = weight s and wt = weight t in ws < wt || (ws = wt && match (s, t) with
    | A(f,[s]), V v -> kbo1 f v s
    | A(f,ss), A(g,ts) -> g > f || (f = g && kbo2 (ss, ts))
    | _ -> false)
and kbo2 = function
  | (si :: ss, ti :: ts) -> if si = ti then kbo2 (ss, ts) else kbo si ti
  | _ -> false;;


let rec lpo s t = match (s, t) with
  | A (f, ss), A(g, ts) ->
      (f = g && lpo2 s (ss, ts)) ||
      (f > g && List.for_all (lpo s) ts) ||
      (List.exists (fun si -> si = t || lpo si t) ss)
  | A (f, ss), _ -> List.exists (fun si -> si = t || lpo si t) ss
  | _ -> false
and lpo2 s = function
  | (si :: ss, ti :: ts) -> if si = ti then lpo2 s (ss, ts) else (lpo si ti && List.for_all (lpo s) ts)
  | _ -> false;;
