FLYMESON := $(shell find flyspeck-meson/  -type f -name "*f*.p" | sort -R)
FLYTOP   := $(shell find flyspeck-top/    -type f -name "*f*.p" | sort -R)
FLYTOP10 := $(shell find flyspeck-top10/  -type l -name "*f*.p" | sort -R)

HLMESON  := $(shell find hol-light-meson/ -type f -name "*f*.p" | sort -R)
HLTOP    := $(shell find hol-light-top/   -type f -name "*f*.p" | sort -R)

flyspeck-top.tar.bz2:
	wget http://cl-informatik.uibk.ac.at/~mfaerber/cop/$@ -O $@

flyspeck-top: flyspeck-top.tar.bz2
	tar xjf $<

flyspeck-meson.tar.bz2:
	wget http://cl-informatik.uibk.ac.at/~mfaerber/cop/$@ -O $@

flyspeck-meson: flyspeck-meson.tar.bz2
	tar xjf $<

flyspeck-top10: flyspeck-top
	mkdir -p $@
	find $< -name "*f*0.p" -exec ln -rsf \{\} $@ \;

hol-light-top.tar.bz2:
	wget http://cl-informatik.uibk.ac.at/~mfaerber/cop/$@ -O $@

hol-light-top: hol-light-top.tar.bz2
	tar xjf $<

hol-light-meson.tar.bz2:
	wget http://cl-informatik.uibk.ac.at/~mfaerber/cop/$@ -O $@

hol-light-meson: hol-light-meson.tar.bz2
	tar xjf $<
