include eprover.mk
include vampire.mk
include metis.mk
include cop.mk

# exit gracefully in case of timeout by catching exit code 124
timeout = `which timeout` -k 1 $(1) $(2) || \
  if [ $$? = 124 ]; then exit 0; else exit $$?; fi

run-atp = mkdir -p `dirname $@` && \
  (`which time` -o $@.time $(call timeout,$(1),$(2))) > $@

define jar-atps =

out/$(1)/jar/e-2.0: $$($(2):$(1)/%=\
out/$(1)/jar/e-2.0/%)
out/$(1)/jar/e-2.0/%: eprover-2.0 $(1)/%
	-$$(call run-atp,10,./$$^ --tptp3-in --silent --proof-object)

out/$(1)/jar/e-2.0-auto: $$($(2):$(1)/%=\
out/$(1)/jar/e-2.0-auto/%)
out/$(1)/jar/e-2.0-auto/%: eprover-2.0 $(1)/%
	-$$(call run-atp,10,./$$^ --auto --tptp3-in --silent --proof-object)

out/$(1)/jar/vampire-4.0: $$($(2):$(1)/%=\
out/$(1)/jar/vampire-4.0/%)
out/$(1)/jar/vampire-4.0/%: vampire-4.0 $(1)/%
	-$$(call run-atp,10,./$$^)

out/$(1)/jar/metis-20171021: $$($(2):$(1)/%=\
out/$(1)/jar/metis-20171021/%)
out/$(1)/jar/metis-20171021/%: metis-2.3-20171021 $(1)/%
	-$$(call run-atp,10,./$$^)

out/$(1)/jar/meson-151209: $$($(2):$(1)/%=\
out/$(1)/jar/meson-151209/%)
out/$(1)/jar/meson-151209/%: cop-151209/meson $(1)/%
	-$$(call run-atp,10,./$$^)

out/$(1)/jar/nanocop-171126-cut: $$($(2):$(1)/%=\
out/$(1)/jar/nanocop-171126-cut/%)
out/$(1)/jar/nanocop-171126-cut/%: cop-171126/nanocop.native $(1)/%
	-$$(call run-atp,10,./$$^ -schedule 0)

out/$(1)/jar/nanocop-171126-nocut: $$($(2):$(1)/%=\
out/$(1)/jar/nanocop-171126-nocut/%)
out/$(1)/jar/nanocop-171126-nocut/%: cop-171126/nanocop.native $(1)/%
	-$$(call run-atp,10,./$$^ -schedule 0 -nocut)

out/$(1)/jar/plnanocop-171116-cut: $$($(2):$(1)/%=\
out/$(1)/jar/plnanocop-171116-cut/%)
out/$(1)/jar/plnanocop-171116-cut/%: cop-171116/prolog/nanocop.sh $(1)/%
	-export SET='[cut,infs]'; $$(call run-atp,10,./$$^)

out/$(1)/jar/plnanocop-171116-nocut: $$($(2):$(1)/%=\
out/$(1)/jar/plnanocop-171116-nocut/%)
out/$(1)/jar/plnanocop-171116-nocut/%: cop-171116/prolog/nanocop.sh $(1)/%
	-export SET='[infs]'; $$(call run-atp,10,./$$^)

out/$(1)/jar/streamcop-171126-nodef-cut-conj: $$($(2):$(1)/%=\
out/$(1)/jar/streamcop-171126-nodef-cut-conj/%)
out/$(1)/jar/streamcop-171126-nodef-cut-conj/%: cop-171126/streamcop.native $(1)/%
	-$$(call run-atp,10,./$$^ -schedule 0 -nodefcnf)

out/$(1)/jar/streamcop-171126-nodef-cut-noconj: $$($(2):$(1)/%=\
out/$(1)/jar/streamcop-171126-nodef-cut-noconj/%)
out/$(1)/jar/streamcop-171126-nodef-cut-noconj/%: cop-171126/streamcop.native $(1)/%
	-$$(call run-atp,10,./$$^ -schedule 0 -nodefcnf -noconj)

out/$(1)/jar/streamcop-171126-nodef-nocut-conj: $$($(2):$(1)/%=\
out/$(1)/jar/streamcop-171126-nodef-nocut-conj/%)
out/$(1)/jar/streamcop-171126-nodef-nocut-conj/%: cop-171126/streamcop.native $(1)/%
	-$$(call run-atp,10,./$$^ -schedule 0 -nodefcnf -nocut)

out/$(1)/jar/streamcop-171126-nodef-nocut-noconj: $$($(2):$(1)/%=\
out/$(1)/jar/streamcop-171126-nodef-nocut-noconj/%)
out/$(1)/jar/streamcop-171126-nodef-nocut-noconj/%: cop-171126/streamcop.native $(1)/%
	-$$(call run-atp,10,./$$^ -schedule 0 -nodefcnf -nocut -noconj)

out/$(1)/jar/plleancop-171116-nodef-cut-conj: $$($(2):$(1)/%=\
out/$(1)/jar/plleancop-171116-nodef-cut-conj/%)
out/$(1)/jar/plleancop-171116-nodef-cut-conj/%: cop-171116/prolog/leancop.sh $(1)/%
	-export SET='[nodef,cut,conj,infs]'; $$(call run-atp,10,./$$^)

out/$(1)/jar/plleancop-171116-nodef-cut-noconj: $$($(2):$(1)/%=\
out/$(1)/jar/plleancop-171116-nodef-cut-noconj/%)
out/$(1)/jar/plleancop-171116-nodef-cut-noconj/%: cop-171116/prolog/leancop.sh $(1)/%
	-export SET='[nodef,cut,infs]'; $$(call run-atp,10,./$$^)

out/$(1)/jar/plleancop-171116-nodef-nocut-conj: $$($(2):$(1)/%=\
out/$(1)/jar/plleancop-171116-nodef-nocut-conj/%)
out/$(1)/jar/plleancop-171116-nodef-nocut-conj/%: cop-171116/prolog/leancop.sh $(1)/%
	-export SET='[nodef,conj,infs]'; $$(call run-atp,10,./$$^)

out/$(1)/jar/plleancop-171116-nodef-nocut-noconj: $$($(2):$(1)/%=\
out/$(1)/jar/plleancop-171116-nodef-nocut-noconj/%)
out/$(1)/jar/plleancop-171116-nodef-nocut-noconj/%: cop-171116/prolog/leancop.sh $(1)/%
	-export SET='[nodef,infs]'; $$(call run-atp,10,./$$^)

out/$(1)/jar/stackcop-171110-nodef-cut-conj: $$($(2):$(1)/%=\
out/$(1)/jar/stackcop-171110-nodef-cut-conj/%)
out/$(1)/jar/stackcop-171110-nodef-cut-conj/%: cop-171110/stackcop.native $(1)/%
	-$$(call run-atp,10,./$$^ -schedule 0 -nodefcnf)

out/$(1)/jar/stackcop-171128-nodef-cut-conj-listsub: $$($(2):$(1)/%=\
out/$(1)/jar/stackcop-171128-nodef-cut-conj-listsub/%)
out/$(1)/jar/stackcop-171128-nodef-cut-conj-listsub/%: cop-171128/stackcop.native $(1)/%
	-$$(call run-atp,10,./$$^ -schedule 0 -nodefcnf -noarraysub)

out/$(1)/jar/conticop-171110-nodef-cut-conj: $$($(2):$(1)/%=\
out/$(1)/jar/conticop-171110-nodef-cut-conj/%)
out/$(1)/jar/conticop-171110-nodef-cut-conj/%: cop-171110/conticop.native $(1)/%
	-$$(call run-atp,10,./$$^ -schedule 0 -nodefcnf)

out/$(1)/jar/lazycop-171110-nodef-cut-conj: $$($(2):$(1)/%=\
out/$(1)/jar/lazycop-171110-nodef-cut-conj/%)
out/$(1)/jar/lazycop-171110-nodef-cut-conj/%: cop-171110/lazycop.native $(1)/%
	-$$(call run-atp,10,./$$^ -schedule 0 -nodefcnf)

out/$(1)/jar/nanocop-171110-cut: $$($(2):$(1)/%=\
out/$(1)/jar/nanocop-171110-cut/%)
out/$(1)/jar/nanocop-171110-cut/%: cop-171110/nanocop.native $(1)/%
	-$$(call run-atp,10,./$$^ -schedule 0)



$(1)JARSUBDIRS = \
  out/$(1)/jar/e-2.0 \
  out/$(1)/jar/e-2.0-auto \
  out/$(1)/jar/vampire-4.0 \
  out/$(1)/jar/metis-20171005 \
  out/$(1)/jar/nanocop-171126-cut \
  out/$(1)/jar/nanocop-171126-nocut \
  out/$(1)/jar/plnanocop-171116-cut \
  out/$(1)/jar/plnanocop-171116-nocut \
  out/$(1)/jar/streamcop-171126-nodef-cut-conj \
  out/$(1)/jar/streamcop-171126-nodef-cut-noconj \
  out/$(1)/jar/streamcop-171126-nodef-nocut-conj \
  out/$(1)/jar/streamcop-171126-nodef-nocut-noconj \
  out/$(1)/jar/plleancop-171116-nodef-cut-conj \
  out/$(1)/jar/plleancop-171116-nodef-cut-noconj \
  out/$(1)/jar/plleancop-171116-nodef-nocut-conj \
  out/$(1)/jar/plleancop-171116-nodef-nocut-noconj

out/$(1)/jar: $$($(1)JARSUBDIRS)

.PHONY: $$($(1)JARSUBDIRS) out/$(1)/jar

endef



MCARGS = -exppol cutcla -mlmean arit -maxiters 27 -simdepth 20
MCARGSNAME = epcc-mla-mi27-sd20

define jar-learn =


###########
# FEMaLeCoP
###########

out/$(1)/jarl/leancop-150530-60s-nodef: $$($(2):$(1)/%=\
out/$(1)/jarl/leancop-150530-60s-nodef/%)
out/$(1)/jarl/leancop-150530-60s-nodef/%: cop-150530/leancop $(1)/%
	-$$(call run-atp,60,$$^ -nodef)

out/$(1)/jarl/leancop-%.data: \
out/$(1)/jarl/leancop-%
	cat $$</*.p > $$@

out/$(1)/jarl/leancop-150530-%.datai: cop-150530/hasher \
out/$(1)/jarl/leancop-150530-%.data
	$$(hasher-wrap)

out/$(1)/jarl/leancop-150530-60s-nodef-fns-learn: $$($(2):$(1)/%=\
out/$(1)/jarl/leancop-150530-60s-nodef-fns-learn/%)
out/$(1)/jarl/leancop-150530-60s-nodef-fns-learn/%: \
out/$(1)/jarl/leancop-150530-60s-nodef.datai cop-150530/leancop $(1)/%
	-$$(call run-atp,60,$$(filter-out $$<,$$^) -nodef -feanosubst -datai $$< -learn)


##########
# monteCoP
##########

out/$(1)/jarl/lazycop-170209-60s-md10.ldata: \
out/$(1)/jarl/lazycop-170209-60s-md10 cop-170209/accumstats.native
	cat $$</*.trace | cop-170209/accumstats.native > $$@

out/$(1)/jarl/lazycop-170209-60s-md10.cdata: \
cop-170209/hasher.native out/$(1)/jarl/lazycop-170209-60s-md10
	$$^/*.p -o $$@

out/$(1)/jarl/lazycop-170209-60s-md10: $$($(2):$(1)/%=\
out/$(1)/jarl/lazycop-170209-60s-md10/%)
out/$(1)/jarl/lazycop-170209-60s-md10/%: cop-170209/lazycop.native $(1)/%
	-$$(call run-atp,60,./$$^ -trace $@.trace -maxdepth 10 -mlproof)

out/$(1)/jarl/lazycop-170209-10s-cut: $$($(2):$(1)/%=\
out/$(1)/jarl/lazycop-170209-10s-cut/%)
out/$(1)/jarl/lazycop-170209-10s-cut/%: cop-170209/lazycop.native $(1)/%
	-$$(call run-atp,10,./$$^ -schedule 0)

out/$(1)/jarl/lazycop-170209-10s-nocut: $$($(2):$(1)/%=\
out/$(1)/jarl/lazycop-170209-10s-nocut/%)
out/$(1)/jarl/lazycop-170209-10s-nocut/%: cop-170209/lazycop.native $(1)/%
	-$$(call run-atp,10,./$$^ -schedule 0 -nocut1 -nocut2 -nocut3)

out/$(1)/jarl/montecop-170209-10s-$$(MCARGSNAME): $$($(2):$(1)/%=\
out/$(1)/jarl/montecop-170209-10s-$$(MCARGSNAME)/%)
out/$(1)/jarl/montecop-170209-10s-$$(MCARGSNAME)/%: \
out/$(1)/jarl/lazycop-170209-60s-md10.ldata cop-170209/montecop.native $(1)/%
	-$$(call run-atp,10,$$(filter-out $$<,$$^) -ldata $$< $$(MCARGS))


$(1)JARLSUBDIRS = \
  out/$(1)/jarl/leancop-150530-60s-nodef \
  out/$(1)/jarl/leancop-150530-60s-nodef-fns-learn \
  out/$(1)/jarl/lazycop-170209-60s-md10 \
  out/$(1)/jarl/lazycop-170209-10s-cut \
  out/$(1)/jarl/lazycop-170209-10s-nocut \
  out/$(1)/jarl/montecop-170209-10s-$$(MCARGSNAME)

out/$(1)/jarl: $$($(1)JARLSUBDIRS)

.PHONY: $$($(1)JARLSUBDIRS) out/$(1)/jarl

endef
