# input files (FOF/CNF TPTP files contain either + or - in filename)
#TPTP630    = $(shell find TPTP-v6.3.0/ -type f -regex ".*\(\+\|-\).*\.p" | sort -R)
TPTP370FOF_ORIG := $(shell find TPTP-v3.7.0/ -type f -name "*+?.p" | sort -R)
TPTP630FOF_ORIG := $(shell find TPTP-v6.3.0/ -type f -name "*+?.p" | sort -R)

TPTP370FOF := $(shell find tptp370/ -type f -name "*+?.p" | sort -R)
TPTP630FOF := $(shell find tptp630/ -type f -name "*+?.p" | sort -R)

TPTP-%.tgz:
	wget http://www.cs.miami.edu/~tptp/TPTP/Archive/$@

TPTP-%: TPTP-%.tgz
	tar xzf $<
	tar xzf $@/$<
	rm $@/$<

tptp4X: TPTP-v6.3.0
	ln -sf $</Scripts/tptp4X $@

.PHONY: tptp370 tptp630

# omit problems for which tptp4X segfaults (e.g. PLA035+1.p)
tptp370: $(TPTP370FOF_ORIG:TPTP-v3.7.0/Problems/%=tptp370/%)
tptp370/%: TPTP-v3.7.0/Problems/%
	@mkdir -p "`dirname $@`"
	TPTP=TPTP-v3.7.0 `which timeout` 10 ./tptp4X -x -N -t fofify "$<" > "$@" || rm "$@"

tptp630: $(TPTP630FOF_ORIG:TPTP-v6.3.0/Problems/%=tptp630/%)
tptp630/%: TPTP-v6.3.0/Problems/%
	@mkdir -p "`dirname $@`"
	TPTP=TPTP-v6.3.0 `which timeout` 10 ./tptp4X -x -N -t fofify "$<" > "$@" || rm "$@"
