open Format
open Print
open Ncmatrix

let rec pp_print_litmat fi f = function
    Lit l -> pp_print_lit f l
  | Mat m -> pp_print_imatrix fi f m
and pp_print_imatrix fi f (i, m) =
  pp_open_box f 1;
  fi f i;
  pp_print_matrix fi f m;
  pp_close_box f ()
and pp_print_matrix fi =
  pp_with_box 1 (pp_enclose_cut "[" "]" (pp_iter_sp "&" (pp_print_iclause fi)))
and pp_print_iclause fi f ((i, v), c) =
  pp_open_box f 1;
  fi f i;
  pp_enum "," "{" "}" pp_print_var f v; pp_print_char f ':'; pp_print_space f ();
  pp_print_nclause fi f c;
  pp_close_box f ()
and pp_print_nclause fi =
  pp_with_box 1 (pp_enclose_cut "[" "]" (pp_iter_sp  "|" (pp_print_litmat fi)))

let pp_print_index = pp_enclose "<" ">" pp_print_int
let pp_print_index_copy = pp_enclose "<" ">" (pp_print_pair "," pp_print_int)


let string_of_iclause c = print_to_string (pp_print_iclause pp_print_null) c
let string_of_iclause_i = print_to_string (pp_print_iclause pp_print_index)
let string_of_iclause_ic = print_to_string (pp_print_iclause pp_print_index_copy)
let string_of_nclause c = print_to_string (pp_print_nclause pp_print_null) c
let string_of_nclause_ic c = print_to_string (pp_print_nclause pp_print_index_copy) c
let string_of_matrix m = print_to_string (pp_print_matrix pp_print_null) m

let print_iclause c = pp_nl (pp_print_iclause pp_print_null) std_formatter c
let print_iclause_i = pp_nl (pp_print_iclause pp_print_index) std_formatter
let print_iclause_ic = pp_nl (pp_print_iclause pp_print_index_copy) std_formatter
let print_nclause c = pp_nl (pp_print_nclause pp_print_null) std_formatter c
let print_matrix_i = pp_nl (pp_print_matrix pp_print_index) Format.std_formatter
let print_matrix_ic = pp_nl (pp_print_matrix pp_print_index_copy) Format.std_formatter

