open Mapping
open Fof
open Utils
open Arglean.Cop
open Arglean.Trace
open Print

let add_hash = function
    Impl (ax, cj) -> Impl (Conj (ax, hash_fof), Conj (hash_fof, cj))
  | f -> f

let nocontent_skolem () =
  let skolem_no = ref 0 in
  fun tm pos -> incr skolem_no; "sk" ^ string_of_int !skolem_no

let content_skolem tm pos =
  "'skolem(" ^ String.filter ((<>) '\'') (Print.string_of_form tm) ^ "," ^ pos ^ ")'"

let skolem content inner =
  skolem_form const_number (if content then content_skolem else nocontent_skolem ()) inner

let prematrix_of_sform unfold conj paths =
  map_form_vars Mapping.var_of_string %>
  Equality.equal_axioms Mapping.eqn %>
  (if !verbose then tap print_form else identity) %>
  (if conj then add_hash else identity) %>
  fix_form unfold %>
  (if !Arglean.Prematrix.miniscope then miniscope else identity) %>
  neg %> nnf %>
  (if paths then reorder %> snd else identity) %>
  rename_form true %>
  skolem !content !Arglean.Prematrix.innersk
